#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_GiftGuideCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_GiftGuideCFG> M_GiftGuideCFG::msSingleton(nullptr);

int M_GiftGuideCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_GiftGuideCFGData* M_GiftGuideCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_GiftGuideCFGData>& M_GiftGuideCFG::GetMapData()
{
	return mMapData;
}

void M_GiftGuideCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_GiftGuideCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_GiftGuideCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mNeedLevel = element->IntAttribute("NeedLevel");
		data.mType = element->IntAttribute("Type");
		data.mRechangeID = element->IntAttribute("RechangeID");
		data.mContinueTime = element->IntAttribute("ContinueTime");
		{
			const char* AwardItem = element->Attribute("AwardItem");
			std::vector<std::string> vecAwardItem;
			boost::split(vecAwardItem, AwardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItem[i].c_str(), &temp))
				{
					data.mAwardItem.push_back(temp);
				}
			}
		}
		data.mParam = element->IntAttribute("Param");
		data.mTitleImage = element->Attribute("TitleImage");
		data.mLeftImage = element->Attribute("LeftImage");
		data.mRMBImage = element->Attribute("RMBImage");
		{
			const char* GemPrice = element->Attribute("GemPrice");
			std::vector<std::string> vecGemPrice;
			boost::split(vecGemPrice, GemPrice, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGemPrice.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGemPrice[i].c_str(), &temp))
				{
					data.mGemPrice.push_back(temp);
				}
			}
		}
		data.mStartTime = element->Attribute("StartTime");
		data.mEndTime = element->Attribute("EndTime");
		data.mRefreshWeekDay = element->IntAttribute("RefreshWeekDay");
		data.mBuyCount = element->IntAttribute("BuyCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_GiftGuideCFG::Load()
{
	Load("../Config/M_GiftGuideCFG.xml");
}

M_GiftGuideCFG* M_GiftGuideCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_GiftGuideCFG());
	}
	return msSingleton.get();
}
